#include <bits/stdc++.h>
#define int long long
using namespace std;
int n,k,a[1048576],ans,p[30];
void print()
{
    int br=0,m=-1,pr=0;
    for(int i=1; i<=n; i++)br+=p[i];
    if(br!=k-1)return;
    for(int i=1; i<=n; i++)
    {
        if(p[i])
        {
            if(m==-1)m=pr;
            else m=(m&pr);
            pr=0;
        }
        pr=(pr|a[i]);
    }
    if(m==-1)m=pr;
    else m=(m&pr);
    ans=max(ans,m);
}
void rek(int pos)
{
    for(int i=0; i<2; i++)
    {
        p[pos]=i;
        if(pos==n)print();
        else rek(pos+1);
    }
}
signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin>>n>>k;
    for(int i=1; i<=n; i++)
    {
        cin>>a[i];
    }
    rek(1);
    cout<<ans<<endl;
    return 0;
}
